#!/usr/bin/env python
from gimpfu import *
#Distinct Types: seed,curve,audiofragment,filepath,path,int,object,enum,double,boolean,format,pointer,color,uri,string
#Type Lines: name: cpn-1-keep type: boolean default: False label:[color-model {rgb} : rgb-label, color-model {hsl} : hsl-label] rgb-label:Keep red component hsl-label:Keep hue component
#name: d type: path
#name: uri type: uri  default:
#name: space-name type: string  default: sRGB
#name: buffer type: pointer
#name: buffer type: object
#name: curve type: curve
#name: subdivisions type: int default: 1 minimum: 0 maximum: 15 ui-minimum: 0 ui-maximum: 15 ui-gamma: 1.00 ui-step-small: 1 ui-step-big: 5
#name: audio type: audiofragment
#name: color-model type: enum
#name: input-format type: format
#name: seed type: seed
#name: background-color type: color default: rgba(0.000, 0.000, 0.000, 0.000) sensitive:! keep_surroundings role:color-secondary
#name: path type: filepath  default:
#name: value type: double default: 0.00 minimum: -inf maximum: +inf ui-minimum: -1.00 ui-maximum: 1.00 ui-gamma: 1.00 ui-step-small: 0.00 ui-step-big: 0.10 ui-digits: 3
#---------------------------------------------------------------------------------------------
def gegl_absolute(image, layer, ):

    gegl_graph_string="gegl:absolute " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_absolute",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-absolute...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_absolute)

#---------------------------------------------------------------------------------------------
def gegl_antialias(image, layer, ):

    gegl_graph_string="gegl:antialias " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_antialias",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-antialias...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_antialias)

#---------------------------------------------------------------------------------------------
def gegl_bilateral_filter(image, layer, blur_radius,edge_preservation):

    gegl_graph_string="gegl:bilateral-filter blur-radius=%f edge-preservation=%f " % (blur_radius,edge_preservation)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_bilateral_filter",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-bilateral-filter...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "blur_radius","blur-radius (default:4.0, 0.0..100.0):", 4.0),
    (PF_FLOAT, "edge_preservation","edge-preservation (default:8.0, 0.0..100.0):", 8.0)
    ],
    [],
    gegl_bilateral_filter)

#---------------------------------------------------------------------------------------------
def gegl_bloom(image, layer, threshold,softness,radius,strength,limit_exposure):

    gegl_graph_string="gegl:bloom threshold=%f softness=%f radius=%f strength=%f limit-exposure=%d " % (threshold,softness,radius,strength,limit_exposure)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_bloom",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-bloom...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "threshold","threshold (default:50.0, 0.0..100.0):", 50.0),
    (PF_FLOAT, "softness","softness (default:25.0, 0.0..100.0):", 25.0),
    (PF_FLOAT, "radius","radius (default:10.0, 0.0..100.0):", 10.0),
    (PF_FLOAT, "strength","strength (default:50.0, 0.0..100.0):", 50.0),
    (PF_TOGGLE, "limit_exposure","limit-exposure (default:True):",True)
    ],
    [],
    gegl_bloom)

#---------------------------------------------------------------------------------------------
def gegl_box_blur(image, layer, radius):

    gegl_graph_string="gegl:box-blur radius=%d " % (radius)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_box_blur",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-box-blur...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "radius", "radius (default:4, 0..100):", 4, (0, 100, 1))
    ],
    [],
    gegl_box_blur)

#---------------------------------------------------------------------------------------------
def gegl_brightness_contrast(image, layer, brightness):

    gegl_graph_string="gegl:brightness-contrast brightness=%f " % (brightness)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_brightness_contrast",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-brightness-contrast...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "brightness","brightness (default:0.0, -1.0..1.0):", 0.0)
    ],
    [],
    gegl_brightness_contrast)

#---------------------------------------------------------------------------------------------
def gegl_c2g(image, layer, radius,samples,iterations,enhance_shadows):

    gegl_graph_string="gegl:c2g radius=%d samples=%d iterations=%d enhance-shadows=%d " % (radius,samples,iterations,enhance_shadows)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_c2g",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-c2g...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "radius", "radius (default:300, 2..1000):", 300, (2, 1000, 1)),
    (PF_SPINNER, "samples", "samples (default:4, 3..17):", 4, (3, 17, 1)),
    (PF_SPINNER, "iterations", "iterations (default:10, 1..30):", 10, (1, 30, 1)),
    (PF_TOGGLE, "enhance_shadows","enhance-shadows (default:True):",True)
    ],
    [],
    gegl_c2g)

#---------------------------------------------------------------------------------------------
def gegl_cartoon(image, layer, mask_radius,pct_black):

    gegl_graph_string="gegl:cartoon mask-radius=%f pct-black=%f " % (mask_radius,pct_black)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_cartoon",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-cartoon...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "mask_radius","mask-radius (default:7.0, 0.0..50.0):", 7.0),
    (PF_FLOAT, "pct_black","pct-black (default:0.2, 0.0..1.0):", 0.2)
    ],
    [],
    gegl_cartoon)

#---------------------------------------------------------------------------------------------
def gegl_channel_mixer(image, layer, preserve_luminosity,rr_gain,rg_gain,rb_gain,gr_gain,gg_gain,gb_gain,br_gain,bg_gain,bb_gain):

    gegl_graph_string="gegl:channel-mixer preserve-luminosity=%d rr-gain=%f rg-gain=%f rb-gain=%f gr-gain=%f gg-gain=%f gb-gain=%f br-gain=%f bg-gain=%f bb-gain=%f " % (preserve_luminosity,rr_gain,rg_gain,rb_gain,gr_gain,gg_gain,gb_gain,br_gain,bg_gain,bb_gain)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_channel_mixer",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-channel-mixer...",             #Menu path
    "*", 
    [
    (PF_TOGGLE, "preserve_luminosity","preserve-luminosity (default:True):",True),
    (PF_FLOAT, "rr_gain","rr-gain (default:1.0, -2.0..2.0):", 1.0),
    (PF_FLOAT, "rg_gain","rg-gain (default:0.0, -2.0..2.0):", 0.0),
    (PF_FLOAT, "rb_gain","rb-gain (default:0.0, -2.0..2.0):", 0.0),
    (PF_FLOAT, "gr_gain","gr-gain (default:0.0, -2.0..2.0):", 0.0),
    (PF_FLOAT, "gg_gain","gg-gain (default:1.0, -2.0..2.0):", 1.0),
    (PF_FLOAT, "gb_gain","gb-gain (default:0.0, -2.0..2.0):", 0.0),
    (PF_FLOAT, "br_gain","br-gain (default:0.0, -2.0..2.0):", 0.0),
    (PF_FLOAT, "bg_gain","bg-gain (default:0.0, -2.0..2.0):", 0.0),
    (PF_FLOAT, "bb_gain","bb-gain (default:1.0, -2.0..2.0):", 1.0)
    ],
    [],
    gegl_channel_mixer)

#---------------------------------------------------------------------------------------------
def gegl_clone(image, layer, ref):

    gegl_graph_string="gegl:clone ref=%s " % (ref)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_clone",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-clone...",             #Menu path
    "*", 
    [
    (PF_STRING, "ref", "ref(default:ID):", "ID")
    ],
    [],
    gegl_clone)

#---------------------------------------------------------------------------------------------
def gegl_color_assimilation_grid(image, layer, grid_size,saturation,angle,line_thickness):

    gegl_graph_string="gegl:color-assimilation-grid grid-size=%f saturation=%f angle=%f line-thickness=%f " % (grid_size,saturation,angle,line_thickness)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_color_assimilation_grid",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-color-assimilation-grid...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "grid_size","grid-size (default:23.0, 0.0..40.0):", 23.0),
    (PF_FLOAT, "saturation","saturation (default:2.5, 0.0..10.0):", 2.5),
    (PF_FLOAT, "angle","angle (default:45.0, -180.0..180.0):", 45.0),
    (PF_FLOAT, "line_thickness","line-thickness (default:0.4, 0.0..1.0):", 0.4)
    ],
    [],
    gegl_color_assimilation_grid)

#---------------------------------------------------------------------------------------------
def gegl_color_enhance(image, layer, ):

    gegl_graph_string="gegl:color-enhance " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_color_enhance",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-color-enhance...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_color_enhance)

#---------------------------------------------------------------------------------------------
def gegl_color_temperature(image, layer, original_temperature,intended_temperature):

    gegl_graph_string="gegl:color-temperature original-temperature=%f intended-temperature=%f " % (original_temperature,intended_temperature)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_color_temperature",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-color-temperature...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "original_temperature","original-temperature (default:6500.0, 1000.0..12000.0):", 6500.0),
    (PF_FLOAT, "intended_temperature","intended-temperature (default:6500.0, 1000.0..12000.0):", 6500.0)
    ],
    [],
    gegl_color_temperature)

#---------------------------------------------------------------------------------------------
def gegl_difference_of_gaussians(image, layer, radius1,radius2):

    gegl_graph_string="gegl:difference-of-gaussians radius1=%f radius2=%f " % (radius1,radius2)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_difference_of_gaussians",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-difference-of-gaussians...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "radius1","radius1 (default:1.0, 0.0..10.0):", 1.0),
    (PF_FLOAT, "radius2","radius2 (default:2.0, 0.0..20.0):", 2.0)
    ],
    [],
    gegl_difference_of_gaussians)

#---------------------------------------------------------------------------------------------
def gegl_diffraction_patterns(image, layer, red_frequency,green_frequency,blue_frequency,red_contours,green_contours,blue_contours,red_sedges,green_sedges,blue_sedges,brightness,scattering,polarization,width,height):

    gegl_graph_string="gegl:diffraction-patterns red-frequency=%f green-frequency=%f blue-frequency=%f red-contours=%f green-contours=%f blue-contours=%f red-sedges=%f green-sedges=%f blue-sedges=%f brightness=%f scattering=%f polarization=%f width=%d height=%d " % (red_frequency,green_frequency,blue_frequency,red_contours,green_contours,blue_contours,red_sedges,green_sedges,blue_sedges,brightness,scattering,polarization,width,height)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_diffraction_patterns",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-diffraction-patterns...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "red_frequency","red-frequency (default:0.81, 0.0..20.0):", 0.81),
    (PF_FLOAT, "green_frequency","green-frequency (default:1.22, 0.0..20.0):", 1.22),
    (PF_FLOAT, "blue_frequency","blue-frequency (default:1.12, 0.0..20.0):", 1.12),
    (PF_FLOAT, "red_contours","red-contours (default:0.82, 0.0..10.0):", 0.82),
    (PF_FLOAT, "green_contours","green-contours (default:0.82, 0.0..10.0):", 0.82),
    (PF_FLOAT, "blue_contours","blue-contours (default:0.97, 0.0..10.0):", 0.97),
    (PF_FLOAT, "red_sedges","red-sedges (default:0.61, 0.0..1.0):", 0.61),
    (PF_FLOAT, "green_sedges","green-sedges (default:0.68, 0.0..1.0):", 0.68),
    (PF_FLOAT, "blue_sedges","blue-sedges (default:0.64, 0.0..1.0):", 0.64),
    (PF_FLOAT, "brightness","brightness (default:0.07, 0.0..1.0):", 0.07),
    (PF_FLOAT, "scattering","scattering (default:37.13, 0.0..100.0):", 37.13),
    (PF_FLOAT, "polarization","polarization (default:-0.47, -1.0..1.0):", -0.47),
    (PF_SPINNER, "width", "width (default:200, 0..4096):", 200, (0, 4096, 1)),
    (PF_SPINNER, "height", "height (default:200, 0..4096):", 200, (0, 4096, 1))
    ],
    [],
    gegl_diffraction_patterns)

#---------------------------------------------------------------------------------------------
def gegl_display(image, layer, window_title):

    gegl_graph_string="gegl:display window-title=%s " % (window_title)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_display",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-display...",             #Menu path
    "*", 
    [
    (PF_STRING, "window_title", "window-title(default:window_title):", "window_title")
    ],
    [],
    gegl_display)

#---------------------------------------------------------------------------------------------
def gegl_domain_transform(image, layer, n_iterations,spatial_factor,edge_preservation):

    gegl_graph_string="gegl:domain-transform n-iterations=%d spatial-factor=%f edge-preservation=%f " % (n_iterations,spatial_factor,edge_preservation)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_domain_transform",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-domain-transform...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "n_iterations", "n-iterations (default:3, 1..5):", 3, (1, 5, 1)),
    (PF_FLOAT, "spatial_factor","spatial-factor (default:30.0, 0.0..1000.0):", 30.0),
    (PF_FLOAT, "edge_preservation","edge-preservation (default:0.8, 0.0..1.0):", 0.8)
    ],
    [],
    gegl_domain_transform)

#---------------------------------------------------------------------------------------------
def gegl_edge_laplace(image, layer, ):

    gegl_graph_string="gegl:edge-laplace " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_edge_laplace",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-edge-laplace...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_edge_laplace)

#---------------------------------------------------------------------------------------------
def gegl_edge_neon(image, layer, radius,amount):

    gegl_graph_string="gegl:edge-neon radius=%f amount=%f " % (radius,amount)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_edge_neon",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-edge-neon...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "radius","radius (default:5.0, 0.0..50.0):", 5.0),
    (PF_FLOAT, "amount","amount (default:0.0, 0.0..3.0):", 0.0)
    ],
    [],
    gegl_edge_neon)

#---------------------------------------------------------------------------------------------
def gegl_edge_sobel(image, layer, horizontal,vertical,keep_sign):

    gegl_graph_string="gegl:edge-sobel horizontal=%d vertical=%d keep-sign=%d " % (horizontal,vertical,keep_sign)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_edge_sobel",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-edge-sobel...",             #Menu path
    "*", 
    [
    (PF_TOGGLE, "horizontal","horizontal (default:True):",True),
    (PF_TOGGLE, "vertical","vertical (default:True):",True),
    (PF_TOGGLE, "keep_sign","keep-sign (default:True):",True)
    ],
    [],
    gegl_edge_sobel)

#---------------------------------------------------------------------------------------------
def gegl_engrave(image, layer, row_height,limit):

    gegl_graph_string="gegl:engrave row-height=%d limit=%d " % (row_height,limit)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_engrave",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-engrave...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "row_height", "row-height (default:10, 2..16):", 10, (2, 16, 1)),
    (PF_TOGGLE, "limit","limit (default:True):",True)
    ],
    [],
    gegl_engrave)

#---------------------------------------------------------------------------------------------
def gegl_exposure(image, layer, black_level,exposure):

    gegl_graph_string="gegl:exposure black-level=%f exposure=%f " % (black_level,exposure)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_exposure",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-exposure...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "black_level","black-level (default:0.0, -0.1..0.1):", 0.0),
    (PF_FLOAT, "exposure","exposure (default:0.0, -10.0..10.0):", 0.0)
    ],
    [],
    gegl_exposure)

#---------------------------------------------------------------------------------------------
def gegl_fattal02(image, layer, alpha,beta,saturation,noise):

    gegl_graph_string="gegl:fattal02 alpha=%f beta=%f saturation=%f noise=%f " % (alpha,beta,saturation,noise)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_fattal02",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-fattal02...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "alpha","alpha (default:1.0, 0.0..2.0):", 1.0),
    (PF_FLOAT, "beta","beta (default:0.9, 0.1..2.0):", 0.9),
    (PF_FLOAT, "saturation","saturation (default:0.8, 0.0..1.0):", 0.8),
    (PF_FLOAT, "noise","noise (default:0.0, 0.0..1.0):", 0.0)
    ],
    [],
    gegl_fattal02)

#---------------------------------------------------------------------------------------------
def gegl_gegl(image, layer, string,error):

    gegl_graph_string="gegl:gegl string=%s error=%s " % (string,error)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_gegl",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-gegl...",             #Menu path
    "*", 
    [
    (PF_STRING, "string", "string(default:#):", "#"),
    (PF_STRING, "error", "error(default:error:true):", "error:true")
    ],
    [],
    gegl_gegl)

#---------------------------------------------------------------------------------------------
def gegl_gray(image, layer, ):

    gegl_graph_string="gegl:gray " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_gray",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-gray...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_gray)

#---------------------------------------------------------------------------------------------
def gegl_high_pass(image, layer, std_dev,contrast):

    gegl_graph_string="gegl:high-pass std-dev=%f contrast=%f " % (std_dev,contrast)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_high_pass",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-high-pass...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "std_dev","std-dev (default:4.0, 0.0..1000.0):", 4.0),
    (PF_FLOAT, "contrast","contrast (default:1.0, 0.0..5.0):", 1.0)
    ],
    [],
    gegl_high_pass)

#---------------------------------------------------------------------------------------------
def gegl_hue_chroma(image, layer, hue,chroma,lightness):

    gegl_graph_string="gegl:hue-chroma hue=%f chroma=%f lightness=%f " % (hue,chroma,lightness)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_hue_chroma",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-hue-chroma...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "hue","hue (default:0.0, -180.0..180.0):", 0.0),
    (PF_FLOAT, "chroma","chroma (default:0.0, -100.0..100.0):", 0.0),
    (PF_FLOAT, "lightness","lightness (default:0.0, -100.0..100.0):", 0.0)
    ],
    [],
    gegl_hue_chroma)

#---------------------------------------------------------------------------------------------
def gegl_invert_gamma(image, layer, ):

    gegl_graph_string="gegl:invert-gamma " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_invert_gamma",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-invert-gamma...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_invert_gamma)

#---------------------------------------------------------------------------------------------
def gegl_invert_linear(image, layer, ):

    gegl_graph_string="gegl:invert-linear " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_invert_linear",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-invert-linear...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_invert_linear)

#---------------------------------------------------------------------------------------------
def gegl_json(image, layer, height,width):

    gegl_graph_string="gegl:json height=%f width=%f " % (height,width)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_json",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-json...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "height","height (default:0.0, -10000..10000):", 0.0),
    (PF_FLOAT, "width","width (default:0.0, -10000..10000):", 0.0)
    ],
    [],
    gegl_json)

#---------------------------------------------------------------------------------------------
def gegl_lens_flare(image, layer, pos_x,pos_y):

    gegl_graph_string="gegl:lens-flare pos-x=%f pos-y=%f " % (pos_x,pos_y)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_lens_flare",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-lens-flare...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "pos_x","pos-x (default:0.5, 0.0..1.0):", 0.5),
    (PF_FLOAT, "pos_y","pos-y (default:0.5, 0.0..1.0):", 0.5)
    ],
    [],
    gegl_lens_flare)

#---------------------------------------------------------------------------------------------
def gegl_levels(image, layer, in_low,in_high,out_low,out_high):

    gegl_graph_string="gegl:levels in-low=%f in-high=%f out-low=%f out-high=%f " % (in_low,in_high,out_low,out_high)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_levels",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-levels...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "in_low","in-low (default:0.0, 0.0..1.0):", 0.0),
    (PF_FLOAT, "in_high","in-high (default:1.0, 0.0..1.0):", 1.0),
    (PF_FLOAT, "out_low","out-low (default:0.0, 0.0..1.0):", 0.0),
    (PF_FLOAT, "out_high","out-high (default:1.0, 0.0..1.0):", 1.0)
    ],
    [],
    gegl_levels)

#---------------------------------------------------------------------------------------------
def gegl_linear_sinusoid(image, layer, x_period,y_period,x_amplitude,y_amplitude,x_phase,y_phase,angle,offset,exponent,x_offset,y_offset,rotation,supersampling):

    gegl_graph_string="gegl:linear-sinusoid x-period=%f y-period=%f x-amplitude=%f y-amplitude=%f x-phase=%f y-phase=%f angle=%f offset=%f exponent=%f x-offset=%f y-offset=%f rotation=%f supersampling=%d " % (x_period,y_period,x_amplitude,y_amplitude,x_phase,y_phase,angle,offset,exponent,x_offset,y_offset,rotation,supersampling)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_linear_sinusoid",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-linear-sinusoid...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "x_period","x-period (default:128.0, 0.0..256.0):", 128.0),
    (PF_FLOAT, "y_period","y-period (default:128.0, 0.0..256.0):", 128.0),
    (PF_FLOAT, "x_amplitude","x-amplitude (default:0.0, -2.0..2.0):", 0.0),
    (PF_FLOAT, "y_amplitude","y-amplitude (default:0.0, -2.0..2.0):", 0.0),
    (PF_FLOAT, "x_phase","x-phase (default:0.0, -512.0..512.0):", 0.0),
    (PF_FLOAT, "y_phase","y-phase (default:0.0, -512.0..512.0):", 0.0),
    (PF_FLOAT, "angle","angle (default:90.0, 0.0..360.0):", 90.0),
    (PF_FLOAT, "offset","offset (default:0.0, -1.0..1.0):", 0.0),
    (PF_FLOAT, "exponent","exponent (default:0.0, -2.0..2.0):", 0.0),
    (PF_FLOAT, "x_offset","x-offset (default:0.0, -512.0..512.0):", 0.0),
    (PF_FLOAT, "y_offset","y-offset (default:0.0, -512.0..512.0):", 0.0),
    (PF_FLOAT, "rotation","rotation (default:0.0, 0.0..360.0):", 0.0),
    (PF_SPINNER, "supersampling", "supersampling (default:1, 1..8):", 1, (1, 8, 1))
    ],
    [],
    gegl_linear_sinusoid)

#---------------------------------------------------------------------------------------------
def gegl_mantiuk06(image, layer, contrast,saturation,detail):

    gegl_graph_string="gegl:mantiuk06 contrast=%f saturation=%f detail=%f " % (contrast,saturation,detail)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_mantiuk06",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-mantiuk06...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "contrast","contrast (default:0.1, 0.0..1.0):", 0.1),
    (PF_FLOAT, "saturation","saturation (default:0.8, 0.0..2.0):", 0.8),
    (PF_FLOAT, "detail","detail (default:1.0, 1.0..99.0):", 1.0)
    ],
    [],
    gegl_mantiuk06)

#---------------------------------------------------------------------------------------------
def gegl_mblur(image, layer, dampness):

    gegl_graph_string="gegl:mblur dampness=%f " % (dampness)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_mblur",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-mblur...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "dampness","dampness (default:0.95, 0.0..1.0):", 0.95)
    ],
    [],
    gegl_mblur)

#---------------------------------------------------------------------------------------------
def gegl_mean_curvature_blur(image, layer, iterations):

    gegl_graph_string="gegl:mean-curvature-blur iterations=%d " % (iterations)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_mean_curvature_blur",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-mean-curvature-blur...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "iterations", "iterations (default:20, 0..60):", 20, (0, 60, 1))
    ],
    [],
    gegl_mean_curvature_blur)

#---------------------------------------------------------------------------------------------
def gegl_mirrors(image, layer, m_angle,r_angle,n_segs,c_x,c_y,o_x,o_y,trim_x,trim_y,input_scale,output_scale,clip,warp):

    gegl_graph_string="gegl:mirrors m-angle=%f r-angle=%f n-segs=%d c-x=%f c-y=%f o-x=%f o-y=%f trim-x=%f trim-y=%f input-scale=%f output-scale=%f clip=%d warp=%d " % (m_angle,r_angle,n_segs,c_x,c_y,o_x,o_y,trim_x,trim_y,input_scale,output_scale,clip,warp)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_mirrors",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-mirrors...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "m_angle","m-angle (default:0.0, 0.0..180.0):", 0.0),
    (PF_FLOAT, "r_angle","r-angle (default:0.0, 0.0..360.0):", 0.0),
    (PF_SPINNER, "n_segs", "n-segs (default:6, 2..24):", 6, (2, 24, 1)),
    (PF_FLOAT, "c_x","c-x (default:0.5, 0.0..1.0):", 0.5),
    (PF_FLOAT, "c_y","c-y (default:0.5, 0.0..1.0):", 0.5),
    (PF_FLOAT, "o_x","o-x (default:0.0, -1.0..1.0):", 0.0),
    (PF_FLOAT, "o_y","o-y (default:0.0, -1.0..1.0):", 0.0),
    (PF_FLOAT, "trim_x","trim-x (default:0.0, 0.0..0.5):", 0.0),
    (PF_FLOAT, "trim_y","trim-y (default:0.0, 0.0..0.5):", 0.0),
    (PF_FLOAT, "input_scale","input-scale (default:100.0, 0.1..100.0):", 100.0),
    (PF_FLOAT, "output_scale","output-scale (default:1.0, 0.0..100.0):", 1.0),
    (PF_TOGGLE, "clip","clip (default:True):",True),
    (PF_TOGGLE, "warp","warp (default:True):",True)
    ],
    [],
    gegl_mirrors)

#---------------------------------------------------------------------------------------------
def gegl_mono_mixer(image, layer, preserve_luminosity,red,green,blue):

    gegl_graph_string="gegl:mono-mixer preserve-luminosity=%d red=%f green=%f blue=%f " % (preserve_luminosity,red,green,blue)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_mono_mixer",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-mono-mixer...",             #Menu path
    "*", 
    [
    (PF_TOGGLE, "preserve_luminosity","preserve-luminosity (default:True):",True),
    (PF_FLOAT, "red","red (default:0.33, -2.0..2.0):", 0.33),
    (PF_FLOAT, "green","green (default:0.33, -2.0..2.0):", 0.33),
    (PF_FLOAT, "blue","blue (default:0.33, -2.0..2.0):", 0.33)
    ],
    [],
    gegl_mono_mixer)

#---------------------------------------------------------------------------------------------
def gegl_motion_blur_circular(image, layer, center_x,center_y,angle):

    gegl_graph_string="gegl:motion-blur-circular center-x=%f center-y=%f angle=%f " % (center_x,center_y,angle)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_motion_blur_circular",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-motion-blur-circular...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "center_x","center-x (default:0.5, 0.0..1.0):", 0.5),
    (PF_FLOAT, "center_y","center-y (default:0.5, 0.0..1.0):", 0.5),
    (PF_FLOAT, "angle","angle (default:5.0, 0.0..360.0):", 5.0)
    ],
    [],
    gegl_motion_blur_circular)

#---------------------------------------------------------------------------------------------
def gegl_motion_blur_linear(image, layer, length,angle):

    gegl_graph_string="gegl:motion-blur-linear length=%f angle=%f " % (length,angle)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_motion_blur_linear",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-motion-blur-linear...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "length","length (default:10.0, 0.0..300.0):", 10.0),
    (PF_FLOAT, "angle","angle (default:0.0, -180.0..180.0):", 0.0)
    ],
    [],
    gegl_motion_blur_linear)

#---------------------------------------------------------------------------------------------
def gegl_motion_blur_zoom(image, layer, center_x,center_y,factor):

    gegl_graph_string="gegl:motion-blur-zoom center-x=%f center-y=%f factor=%f " % (center_x,center_y,factor)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_motion_blur_zoom",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-motion-blur-zoom...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "center_x","center-x (default:0.5, 0.0..1.0):", 0.5),
    (PF_FLOAT, "center_y","center-y (default:0.5, 0.0..1.0):", 0.5),
    (PF_FLOAT, "factor","factor (default:0.1, -0.5..1.0):", 0.1)
    ],
    [],
    gegl_motion_blur_zoom)

#---------------------------------------------------------------------------------------------
def gegl_noise_reduction(image, layer, iterations):

    gegl_graph_string="gegl:noise-reduction iterations=%d " % (iterations)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_noise_reduction",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-noise-reduction...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "iterations", "iterations (default:4, 0..8):", 4, (0, 8, 1))
    ],
    [],
    gegl_noise_reduction)

#---------------------------------------------------------------------------------------------
def gegl_nop(image, layer, ):

    gegl_graph_string="gegl:nop " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_nop",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-nop...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_nop)

#---------------------------------------------------------------------------------------------
def gegl_open_buffer(image, layer, path):

    gegl_graph_string="gegl:open-buffer path=%s " % (path)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_open_buffer",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-open-buffer...",             #Menu path
    "*", 
    [
    (PF_STRING, "path", "path(default:):", "")
    ],
    [],
    gegl_open_buffer)

#---------------------------------------------------------------------------------------------
def gegl_perlin_noise(image, layer, alpha,scale,zoff,n):

    gegl_graph_string="gegl:perlin-noise alpha=%f scale=%f zoff=%f n=%d " % (alpha,scale,zoff,n)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_perlin_noise",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-perlin-noise...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "alpha","alpha (default:1.2, 0.0..4.0):", 1.2),
    (PF_FLOAT, "scale","scale (default:1.8, 0.0..20.0):", 1.8),
    (PF_FLOAT, "zoff","zoff (default:-1.0, -1.0..8.0):", -1.0),
    (PF_SPINNER, "n", "n (default:3, 0..20):", 3, (0, 20, 1))
    ],
    [],
    gegl_perlin_noise)

#---------------------------------------------------------------------------------------------
def gegl_photocopy(image, layer, mask_radius,sharpness,black,white):

    gegl_graph_string="gegl:photocopy mask-radius=%f sharpness=%f black=%f white=%f " % (mask_radius,sharpness,black,white)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_photocopy",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-photocopy...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "mask_radius","mask-radius (default:10.0, 0.0..50.0):", 10.0),
    (PF_FLOAT, "sharpness","sharpness (default:0.5, 0.0..1.0):", 0.5),
    (PF_FLOAT, "black","black (default:0.2, 0.0..1.0):", 0.2),
    (PF_FLOAT, "white","white (default:0.2, 0.0..1.0):", 0.2)
    ],
    [],
    gegl_photocopy)

#---------------------------------------------------------------------------------------------
def gegl_polar_coordinates(image, layer, depth,angle,bw,top,polar,pole_x,pole_y,middle):

    gegl_graph_string="gegl:polar-coordinates depth=%f angle=%f bw=%d top=%d polar=%d pole-x=%d pole-y=%d middle=%d " % (depth,angle,bw,top,polar,pole_x,pole_y,middle)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_polar_coordinates",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-polar-coordinates...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "depth","depth (default:100.0, 0.0..100.0):", 100.0),
    (PF_FLOAT, "angle","angle (default:0.0, 0.0..360.0):", 0.0),
    (PF_TOGGLE, "bw","bw (default:True):",True),
    (PF_TOGGLE, "top","top (default:True):",True),
    (PF_TOGGLE, "polar","polar (default:True):",True),
    (PF_SPINNER, "pole_x", "pole-x (default:0, 0..10000):", 0, (0, 10000, 1)),
    (PF_SPINNER, "pole_y", "pole-y (default:0, 0..10000):", 0, (0, 10000, 1)),
    (PF_TOGGLE, "middle","middle (default:True):",True)
    ],
    [],
    gegl_polar_coordinates)

#---------------------------------------------------------------------------------------------
def gegl_posterize(image, layer, levels):

    gegl_graph_string="gegl:posterize levels=%d " % (levels)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_posterize",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-posterize...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "levels", "levels (default:8, 1..64):", 8, (1, 64, 1))
    ],
    [],
    gegl_posterize)

#---------------------------------------------------------------------------------------------
def gegl_red_eye_removal(image, layer, threshold):

    gegl_graph_string="gegl:red-eye-removal threshold=%f " % (threshold)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_red_eye_removal",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-red-eye-removal...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "threshold","threshold (default:0.4, 0.0..0.8):", 0.4)
    ],
    [],
    gegl_red_eye_removal)

#---------------------------------------------------------------------------------------------
def gegl_reinhard05(image, layer, brightness,chromatic,light):

    gegl_graph_string="gegl:reinhard05 brightness=%f chromatic=%f light=%f " % (brightness,chromatic,light)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_reinhard05",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-reinhard05...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "brightness","brightness (default:0.0, -100.0..100.0):", 0.0),
    (PF_FLOAT, "chromatic","chromatic (default:0.0, 0.0..1.0):", 0.0),
    (PF_FLOAT, "light","light (default:1.0, 0.0..1.0):", 1.0)
    ],
    [],
    gegl_reinhard05)

#---------------------------------------------------------------------------------------------
def gegl_rgb_clip(image, layer, clip_low,low_limit,clip_high,high_limit):

    gegl_graph_string="gegl:rgb-clip clip-low=%d low-limit=%f clip-high=%d high-limit=%f " % (clip_low,low_limit,clip_high,high_limit)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_rgb_clip",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-rgb-clip...",             #Menu path
    "*", 
    [
    (PF_TOGGLE, "clip_low","clip-low (default:True):",True),
    (PF_FLOAT, "low_limit","low-limit (default:0.0, -2.0..0.0):", 0.0),
    (PF_TOGGLE, "clip_high","clip-high (default:True):",True),
    (PF_FLOAT, "high_limit","high-limit (default:1.0, 1.0..3.0):", 1.0)
    ],
    [],
    gegl_rgb_clip)

#---------------------------------------------------------------------------------------------
def gegl_sdl2_display(image, layer, window_title):

    gegl_graph_string="gegl:sdl2-display window-title=%s " % (window_title)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_sdl2_display",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-sdl2-display...",             #Menu path
    "*", 
    [
    (PF_STRING, "window_title", "window-title(default:window_title):", "window_title")
    ],
    [],
    gegl_sdl2_display)

#---------------------------------------------------------------------------------------------
def gegl_sepia(image, layer, scale,srgb):

    gegl_graph_string="gegl:sepia scale=%f srgb=%d " % (scale,srgb)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_sepia",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-sepia...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "scale","scale (default:1.0, 0.0..1.0):", 1.0),
    (PF_TOGGLE, "srgb","srgb (default:True):",True)
    ],
    [],
    gegl_sepia)

#---------------------------------------------------------------------------------------------
def gegl_shadows_highlights(image, layer, shadows,highlights,whitepoint,radius,compress,shadows_ccorrect,highlights_ccorrect):

    gegl_graph_string="gegl:shadows-highlights shadows=%f highlights=%f whitepoint=%f radius=%f compress=%f shadows-ccorrect=%f highlights-ccorrect=%f " % (shadows,highlights,whitepoint,radius,compress,shadows_ccorrect,highlights_ccorrect)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_shadows_highlights",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-shadows-highlights...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "shadows","shadows (default:0.0, -100.0..100.0):", 0.0),
    (PF_FLOAT, "highlights","highlights (default:0.0, -100.0..100.0):", 0.0),
    (PF_FLOAT, "whitepoint","whitepoint (default:0.0, -10.0..10.0):", 0.0),
    (PF_FLOAT, "radius","radius (default:100.0, 0.1..200.0):", 100.0),
    (PF_FLOAT, "compress","compress (default:50.0, 0.0..100.0):", 50.0),
    (PF_FLOAT, "shadows_ccorrect","shadows-ccorrect (default:100.0, 0.0..100.0):", 100.0),
    (PF_FLOAT, "highlights_ccorrect","highlights-ccorrect (default:50.0, 0.0..100.0):", 50.0)
    ],
    [],
    gegl_shadows_highlights)

#---------------------------------------------------------------------------------------------
def gegl_slic(image, layer, cluster_size,compactness,iterations):

    gegl_graph_string="gegl:slic cluster-size=%d compactness=%d iterations=%d " % (cluster_size,compactness,iterations)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_slic",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-slic...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "cluster_size", "cluster-size (default:32, 2..1024):", 32, (2, 1024, 1)),
    (PF_SPINNER, "compactness", "compactness (default:20, 1..40):", 20, (1, 40, 1)),
    (PF_SPINNER, "iterations", "iterations (default:1, 1..15):", 1, (1, 15, 1))
    ],
    [],
    gegl_slic)

#---------------------------------------------------------------------------------------------
def gegl_snn_mean(image, layer, radius,pairs):

    gegl_graph_string="gegl:snn-mean radius=%d pairs=%d " % (radius,pairs)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_snn_mean",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-snn-mean...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "radius", "radius (default:8, 0..40):", 8, (0, 40, 1)),
    (PF_SPINNER, "pairs", "pairs (default:2, 1..2):", 2, (1, 2, 1))
    ],
    [],
    gegl_snn_mean)

#---------------------------------------------------------------------------------------------
def gegl_softglow(image, layer, glow_radius,brightness,sharpness):

    gegl_graph_string="gegl:softglow glow-radius=%f brightness=%f sharpness=%f " % (glow_radius,brightness,sharpness)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_softglow",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-softglow...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "glow_radius","glow-radius (default:10.0, 1.0..50.0):", 10.0),
    (PF_FLOAT, "brightness","brightness (default:0.3, 0.0..1.0):", 0.3),
    (PF_FLOAT, "sharpness","sharpness (default:0.85, 0.0..1.0):", 0.85)
    ],
    [],
    gegl_softglow)

#---------------------------------------------------------------------------------------------
def gegl_stress(image, layer, radius,samples,iterations,enhance_shadows):

    gegl_graph_string="gegl:stress radius=%d samples=%d iterations=%d enhance-shadows=%d " % (radius,samples,iterations,enhance_shadows)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_stress",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-stress...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "radius", "radius (default:300, 2..1000):", 300, (2, 1000, 1)),
    (PF_SPINNER, "samples", "samples (default:5, 3..17):", 5, (3, 17, 1)),
    (PF_SPINNER, "iterations", "iterations (default:5, 1..30):", 5, (1, 30, 1)),
    (PF_TOGGLE, "enhance_shadows","enhance-shadows (default:True):",True)
    ],
    [],
    gegl_stress)

#---------------------------------------------------------------------------------------------
def gegl_stretch_contrast(image, layer, keep_colors,perceptual):

    gegl_graph_string="gegl:stretch-contrast keep-colors=%d perceptual=%d " % (keep_colors,perceptual)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_stretch_contrast",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-stretch-contrast...",             #Menu path
    "*", 
    [
    (PF_TOGGLE, "keep_colors","keep-colors (default:True):",True),
    (PF_TOGGLE, "perceptual","perceptual (default:True):",True)
    ],
    [],
    gegl_stretch_contrast)

#---------------------------------------------------------------------------------------------
def gegl_stretch_contrast_hsv(image, layer, ):

    gegl_graph_string="gegl:stretch-contrast-hsv " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_stretch_contrast_hsv",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-stretch-contrast-hsv...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_stretch_contrast_hsv)

#---------------------------------------------------------------------------------------------
def gegl_svg_huerotate(image, layer, values):

    gegl_graph_string="gegl:svg-huerotate values=%s " % (values)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_svg_huerotate",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-svg-huerotate...",             #Menu path
    "*", 
    [
    (PF_STRING, "values", "values(default:):", "")
    ],
    [],
    gegl_svg_huerotate)

#---------------------------------------------------------------------------------------------
def gegl_svg_luminancetoalpha(image, layer, ):

    gegl_graph_string="gegl:svg-luminancetoalpha " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_svg_luminancetoalpha",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-svg-luminancetoalpha...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_svg_luminancetoalpha)

#---------------------------------------------------------------------------------------------
def gegl_svg_matrix(image, layer, values):

    gegl_graph_string="gegl:svg-matrix values=%s " % (values)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_svg_matrix",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-svg-matrix...",             #Menu path
    "*", 
    [
    (PF_STRING, "values", "values(default:):", "")
    ],
    [],
    gegl_svg_matrix)

#---------------------------------------------------------------------------------------------
def gegl_svg_saturate(image, layer, values):

    gegl_graph_string="gegl:svg-saturate values=%s " % (values)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_svg_saturate",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-svg-saturate...",             #Menu path
    "*", 
    [
    (PF_STRING, "values", "values(default:):", "")
    ],
    [],
    gegl_svg_saturate)

#---------------------------------------------------------------------------------------------
def gegl_tile(image, layer, offset_x,offset_y):

    gegl_graph_string="gegl:tile offset-x=%d offset-y=%d " % (offset_x,offset_y)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_tile",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-tile...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "offset_x", "offset-x (default:0, 0..1024):", 0, (0, 1024, 1)),
    (PF_SPINNER, "offset_y", "offset-y (default:0, 0..1024):", 0, (0, 1024, 1))
    ],
    [],
    gegl_tile)

#---------------------------------------------------------------------------------------------
def gegl_tile_glass(image, layer, tile_width,tile_height):

    gegl_graph_string="gegl:tile-glass tile-width=%d tile-height=%d " % (tile_width,tile_height)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_tile_glass",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-tile-glass...",             #Menu path
    "*", 
    [
    (PF_SPINNER, "tile_width", "tile-width (default:25, 5..50):", 25, (5, 50, 1)),
    (PF_SPINNER, "tile_height", "tile-height (default:25, 5..50):", 25, (5, 50, 1))
    ],
    [],
    gegl_tile_glass)

#---------------------------------------------------------------------------------------------
def gegl_tile_seamless(image, layer, ):

    gegl_graph_string="gegl:tile-seamless " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_tile_seamless",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-tile-seamless...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_tile_seamless)

#---------------------------------------------------------------------------------------------
def gegl_unpremultiply(image, layer, ):

    gegl_graph_string="gegl:unpremultiply " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_unpremultiply",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-unpremultiply...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_unpremultiply)

#---------------------------------------------------------------------------------------------
def gegl_unsharp_mask(image, layer, std_dev,scale,threshold):

    gegl_graph_string="gegl:unsharp-mask std-dev=%f scale=%f threshold=%f " % (std_dev,scale,threshold)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_unsharp_mask",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-unsharp-mask...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "std_dev","std-dev (default:3.0, 0.0..40.0):", 3.0),
    (PF_FLOAT, "scale","scale (default:0.5, 0.0..10.0):", 0.5),
    (PF_FLOAT, "threshold","threshold (default:0.0, 0.0..1.0):", 0.0)
    ],
    [],
    gegl_unsharp_mask)

#---------------------------------------------------------------------------------------------
def gegl_value_invert(image, layer, ):

    gegl_graph_string="gegl:value-invert " % ()
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_value_invert",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-value-invert...",             #Menu path
    "*", 
    [

    ],
    [],
    gegl_value_invert)

#---------------------------------------------------------------------------------------------
def gegl_wavelet_blur(image, layer, radius):

    gegl_graph_string="gegl:wavelet-blur radius=%f " % (radius)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_wavelet_blur",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-wavelet-blur...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "radius","radius (default:1.0, 0.0..256.0):", 1.0)
    ],
    [],
    gegl_wavelet_blur)

#---------------------------------------------------------------------------------------------
def gegl_whirl_pinch(image, layer, whirl,pinch,radius):

    gegl_graph_string="gegl:whirl-pinch whirl=%f pinch=%f radius=%f " % (whirl,pinch,radius)
    pdb.python_fu_gegl_graph(image, layer, gegl_graph_string)
register(
    "python_fu_gegl_whirl_pinch",
    "GEGL Testing",
    "GEGL Testing",
    "Auto Author",
    "Auto Author",
    "Auto Generated Dated",
    "<Image>/Python-Fu/GEGL-Automated/gegl-whirl-pinch...",             #Menu path
    "*", 
    [
    (PF_FLOAT, "whirl","whirl (default:90.0, -720.0..720.0):", 90.0),
    (PF_FLOAT, "pinch","pinch (default:0.0, -1.0..1.0):", 0.0),
    (PF_FLOAT, "radius","radius (default:1.0, 0.0..2.0):", 1.0)
    ],
    [],
    gegl_whirl_pinch)

main()
#72 out of 256 code sections generated
