from gimpfu import *
import pygtk
import gtk
from sys import argv, platform
from ctypes import *
#import sys
#sys.stderr = open('C:/temp/python-fu-output.txt','a')
#sys.stdout=sys.stderr # So that they both go to the same file

def load_library (library_name):
    if platform == "linux" or platform == "linux2":
        library_name = library_name + '.so.0'
    elif platform == "win32":
        from ctypes.util import find_library
        library_name = find_library (library_name + "-0")
    else:
        raise BaseException ("TODO")
    return CDLL (library_name)
#import sys
#print (sys.version)
gimp = load_library ('libgimp-2.0')
#print (gimp)
#gimp = load_library ('libgimp-3.0')

def gegl_graph(image, drawable, gegl_graph_string):
    class GeglBuffer(Structure):
        pass
    drawable_id = drawable.ID
    
    gegl = load_library ('libgegl-0.4')
    sucess = gegl.gegl_init (None, None)
    gimp.gimp_drawable_get_shadow_buffer.restype = POINTER (GeglBuffer)
    gimp.gimp_drawable_get_buffer.restype        = POINTER (GeglBuffer)

    x = c_int (); y = c_int (); w = c_int (); h = c_int ()
    non_empty,x,y,w,h = pdb.gimp_drawable_mask_intersect (drawable)
    args = [b"string", c_char_p (gegl_graph_string), c_void_p ()]
    
    if non_empty:
        source = gimp.gimp_drawable_get_buffer (drawable_id)
        target = gimp.gimp_drawable_get_shadow_buffer (drawable_id)
        sucess = gegl.gegl_render_op (source, target, "gegl:gegl", *args)
        gegl.gegl_buffer_flush (target)
        gimp.gimp_drawable_merge_shadow (drawable_id, PushUndo = True)
        gimp.gimp_drawable_update (drawable_id, x, y, w, h)
        gimp.gimp_displays_flush ()

register(
   "python_fu_gegl_graph",
   "Do GEGL graph example Tooltip",
   "Do GEGL graph example Additional",
   "dinasset",
   "GimpChat: http://gimpchat.com/viewtopic.php?f=9&t=18040&p=254914#p254914",
   "2020.08.24",
   "Do GEGL graph", 
   "RGB*",
   [
     (PF_IMAGE,      "image",       "Input image", None),
     (PF_DRAWABLE,   "drawable", "Input drawable", None),
     (PF_STRING, "gegl_graph_string", "GEGL Graph String", "gegl:wind")
   ],
   [],
   gegl_graph,
   menu="<Image>/Python-Fu/gegl_graph"
   )

# def dinasset_gegl_example(image, drawable):
#     radius=300
#     samples=4
#     iterations=10
#     enhance_shadows=True
#     gegl_graph_string="gegl:c2g radius=%d samples=%d iterations=%d enhance-shadows=%d" % (radius, samples, iterations, enhance_shadows)
#     dinasset_gegl_graph(image, drawable,gegl_graph_string)
  
#     glow_radius=10.0
#     brightness=0.3
#     sharpness=0.85
#     gegl_graph_string="gegl:softglow glow-radius=%f brightness=%f sharpness=%f" % (glow_radius, brightness, sharpness)
#     dinasset_gegl_graph(image, drawable,gegl_graph_string)

#     wind_style="wind" # accepted values: wind blast
#     direction="top" # accepted values: left right top bottom
#     edge="both" # accepted values: both leading trailing
#     threshold=10
#     strength=10
#     seed=0
#     gegl_graph_string="gegl:wind style=%s direction=%s edge=%s threshold=%d strength=%d seed=%d" % (wind_style, direction, edge, threshold, strength, seed)
#     dinasset_gegl_graph(image, drawable,gegl_graph_string)

#     pdb.gimp_displays_flush(image)


# # menu registration
# register(
#     "python_fu_dinasset_gegl_example",
#     "Do GEGL example Tooltip",
#     "Do GEGL example Additional",
#     "dinasset",
#     "GimpChat: http://gimpchat.com/viewtopic.php?f=9&t=18040&p=254914#p254914",
#     "2020.08.24",
#     "Do GEGL example", 
#     "RGB*",
#     [
#       (PF_IMAGE,      "image",       "Input image", None),
#       (PF_DRAWABLE,   "drawable", "Input drawable", None)
#     ],
#     [],
#     dinasset_gegl_example,
#     menu="<Image>/dinasset/"
#     )

main()
